// You can use the CodeVisionAVR Evaluation version from http://hpinfotech.ro to compile the above code
// Internal oscillator frequency 8 000 000
#include <tiny2313.h>

// Standard Input/Output functions
#include <stdio.h>
#include <delay.h>

// Declare your global variables here

// messages from the transmitter:
#define StartPPM 'a'
#define PreviousFrequency '-'
#define NextFrequency '+'
#define RequestPresetFrequency '?'
#define RequestModuleName 'v'

// messages from the module:
//const unsigned char str1[]={'3','5','A','B','H','F','M','S','V','0','1','2','1','J','a','n',' ','2','1',' ','2','0','0','3','1','2',':','5','4',':','1','4', 0x0d, 0x0a};
//const unsigned char str2a[]={'3','5','A','B','1','8','5','3','5','8','5','0', 0x01};
//const unsigned char str2b[]={'3','5','A','B','1','8','5','3','5','8','5','0', 0x08};
// fixed messages from the module:
const unsigned char str1[]={'F','A','K','E',' ','H','F','M','S',' ','1','.','0',' ', 0x0d, 0x0a};
const unsigned char str2a[]={'F','A','K','E','A','L','L',' ','2','4','0','0', 0x01};
const unsigned char str2b[]={'F','A','K','E','A','L','L',' ','2','4','0','0', 0x08};
const unsigned char str3[]={'@',0x27,0x2d, 0x0d, 0x0a};

void main (void){

// Declare your local variables here
unsigned char incomingByte, i;

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Crystal Oscillator division factor: 1

// Input/Output Ports initialization
// Port A initialization
// Func2=In Func1=In Func0=In 
// State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port D initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 19200
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x06;
UBRRH=0x00;
UBRRL=0x19;

while (1)
 {
      incomingByte = 0;
      do {
      incomingByte = getchar();
            switch (incomingByte){ 
                case RequestModuleName :
                    i=0;   
                     do{ 
                        putchar (str1[i]);
                        }while(str1[i++]!=0x0a); 
                    break;
                case RequestPresetFrequency :
                    i=0;   
                     do{ 
                         putchar (str2a[i]);
						}while(str2a[i++]!=0x01); 
                    delay_ms(100);
                    i=0;   
                    do{ 
                        putchar (str3[i]);
                        }while(str3[i++]!=0x0a); 
                    break;
                case PreviousFrequency :
                    i=0;   
                    do{ 
                        putchar (str2b[i]);
                        }while(str2b[i++]!=0x08); 
                    delay_ms(100);
                    i=0;   
                    do{ 
                        putchar (str3[i]);
                        }while(str3[i++]!=0x0a); 
                break;
                case NextFrequency :
                    i=0;   
                    do{ 
                        putchar (str2b[i]);
                        }while(str2b[i++]!=0x08); 
                    delay_ms(100);
                    i=0;   
                    do{ 
                        putchar (str3[i]);
                        }while(str3[i++]!=0x0a); 
                break;
               };
      }while(incomingByte != StartPPM);
    };
};     

